import java.net.*;
import java.io.*;
import java.util.*;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

class Main {
    public Main(int port, int poolsize) {
	try {
	    NetworkService ns = new NetworkService(port, poolsize);
	    ns.start();
	} catch (IOException  e) {
	    System.out.println(e);
	}
    }
    public static void main(String[] args) {
	if (args.length != 2) {
	    System.out.println("Wrong number of arguments: Main <port> <poolsize>");
	    System.exit(-1);
	}
	int port = Integer.parseInt(args[0]);
	int poolsize = Integer.parseInt(args[1]);

	new Main(port, poolsize);
    }
}
