import java.util.concurrent.Semaphore;

class Counter2 {
    int counter = 0;
    int people = 10;
    Semaphore sem = new Semaphore(1);

    public Counter2() {
	try {	
	    Person[] person = new Person[people];
	    for (int i = 0; i < people; i++) {
		person[i] = new Person();
		person[i].start();
	    }

	    for (int i = 0; i < people; i++) {
		person[i].join();
	    }

	    System.out.println("counter = " + counter);

	} catch (InterruptedException e) {
	    System.out.println(e);
	}
	
    }

    public static void main(String[] args) {
	new Counter2();
    }

    class Person extends Thread {
    	public void run() {
    	    try {
    		boolean enter = false;
    		while(!enter) {
    		    if (sem.availablePermits() == 1) { // |
			                               // | ---> DANGER, RACE CONDITION! 
    			sem.acquire();                 // |      DO NOT USE availablePermits()! Instead use tryAcquire() see Counter3.java
    			System.out.println("The lenght of the queue is " + sem.getQueueLength());
    			counter++;
    			sem.release();
    			enter = true;
    		    } else {
    			// Going for a coffee and come back later
    			// sleep(500);
    		    }
    		}
    	    } catch (InterruptedException e) {
    		System.out.println(e);
     	    }
    	}
    }    
}
