import java.util.concurrent.Semaphore;

class Counter3 {
    int counter = 0;
    int people = 10;
    Semaphore sem = new Semaphore(1);

    public Counter3() {
	try {	
	    Person[] person = new Person[people];
	    for (int i = 0; i < people; i++) {
		person[i] = new Person();
		person[i].start();
	    }

	    for (int i = 0; i < people; i++) {
		person[i].join();
	    }

	    System.out.println("counter = " + counter);

	} catch (InterruptedException e) {
	    System.out.println(e);
	}
	
    }

    public static void main(String[] args) {
	new Counter3();
    }

    class Person extends Thread {
    	public void run() {
	    boolean enter = false;
	    while(!enter) {
		if (sem.tryAcquire()) {    		        
		    System.out.println("The lenght of the queue is " + sem.getQueueLength());
		    counter++;
		    sem.release();
		    enter = true;
		} else {
		    // Going for a coffee and come back later
		    // sleep(500);
		}
	    }
    	}
    }    
}
